#
# Example 3-3
# The guestbook.cgi script.
#

#!/bin/sh
# guestbook.cgi
# Implement a simple guestbook page.
# The set of visitors is kept in a simple database.
# The newguest.cgi script will update the database.
# \
exec tclsh "$0" ${1+"$@"}

# The cgilib.tcl file has helper procedures
# The guestbook.data file has the database
# Both file are in the same directory as the script

set dir [file dirname [info script]]
source [file join $dir cgilib.tcl]
set datafile [file join $dir guestbook.data]

Cgi_Header "Brent's Guestbook" {BGCOLOR=white TEXT=black}
P
if {![file exists $datafile]} {
	puts "No registered guests, yet."
	P 
	puts "Be the first [Link {registered guest!} newguest.html]"
} else {
	puts "The following folks have registered in my GuestBook."
	P 
	puts [Link Register newguest.html]
	H2 Guests
	catch {source $datafile}
	foreach name [lsort [array names Guestbook]] {
		set item $Guestbook($name)
		set homepage [lindex $item 0]
		set markup [lindex $item 1]
		H3 [Link $name $homepage]
		puts $markup
	}
}
Cgi_End


